
package example.micronaut.repository;

import example.micronaut.entity.Product;
import io.micronaut.data.annotation.Query;
import io.micronaut.data.annotation.Repository;
import io.micronaut.data.jpa.repository.JpaRepository;

@Repository
public interface ProductRepository extends JpaRepository<Product, Long> {

    default void createProductIfNotExists(Product product) {
        createProductIfNotExists(product.getId(), product.getCode(), product.getName());
    }

    @Query(value = "insert into products(id, code, name) values(:id, :code, :name)",
        nativeQuery = true
    )
    void createProductIfNotExists(Long id, String code, String name);
}
