
package example.micronaut;

import example.micronaut.entity.Product;
import example.micronaut.service.ProductService;
import io.micronaut.http.annotation.Body;
import io.micronaut.http.annotation.Controller;
import io.micronaut.http.annotation.Get;
import io.micronaut.http.annotation.PathVariable;
import io.micronaut.http.annotation.Post;
import java.util.List;
import java.util.Optional;

@Controller("/product")
public class ProductController {

    private final ProductService productService;

  public ProductController(ProductService productService) {
    this.productService = productService;
  }

  @Get
  public List<Product> getProducts() {
    return productService.getProducts();
  }

  @Get("/{productId}")
    public Optional<Product> getProduct(@PathVariable("productId") Long productId) {
        return productService.getProduct(productId);
    }

  @Post
  public String saveProduct(@Body Product product) {
    productService.saveProduct(product);
    return "Saved!";
  }
}
