package example.micronaut.service;

import example.micronaut.entity.Product;
import example.micronaut.repository.ProductRepository;
import io.micronaut.core.annotation.NonNull;
import jakarta.inject.Singleton;
import java.util.List;
import java.util.Optional;

@Singleton
public class ProductService {

  private final ProductRepository productRepository;

  public ProductService(ProductRepository productRepository) {
    this.productRepository = productRepository;
  }

  public void saveProduct(Product product) {
    productRepository.createProductIfNotExists(product);
  }

  public Optional<Product> getProduct(Long id) {
    return productRepository.findById(id);
  }

  public List<Product> getProducts() {
    return productRepository.findAll();
  }
}
